import numpy as np 
from sklearn import datasets
import matplotlib.pyplot as plt
import sys
import pickle


def vis(a, b, c, d):
	
	f = plt.figure(0)
	maxA = 50
	numA = np.arange(maxA)
	plt.plot(numA, a, 'r-.', label='Collaboration with all')
	plt.plot(numA, b*np.ones(maxA), 'b-.*', markersize=4,label='No collaboration')
	plt.plot(numA, c, 'k-o',markersize=3,label='Our approach')
	plt.plot(numA, d, 'c:', label='Oracle')
	plt.ylim([-7.65, -7.4])
	plt.xlabel('Level of attacks (number of attacked learners)',fontsize=14)
	plt.ylabel('Predictive performance (log MSE)', fontsize=14)
	plt.legend(fontsize=13)
	plt.xticks(fontsize=12)
	plt.yticks(fontsize=10)
	plt.show()

if __name__ == '__main__':
	
	# open a file, where you stored the pickled data
	file = open('experiments__egs1_newest.pickle', 'rb')

	# dump information to that file
	# Every item in the list is the result of one splitting
	# four components (err0,err1,err2s,erros), 
	# where err0 and err1 are two values, err2s and erros are two vectors
	# correspond to "all modules not attacked", "under no pooling", "our method", and "oracle" 
	dat = pickle.load(file)
	l = len(dat)
	print('len={}, n_attack={}'.format(l, len(dat[0][2])))

	all_no_attack = np.array([dat[i][7] for i in range(l)])
	all_no_attack0 = np.mean(all_no_attack, axis=0)
	no_assis = np.array([dat[i][4] for i in range(l)])
	no_assis0 = no_assis.mean()
	our_method = np.array([dat[i][5] for i in range(l)])
	our_method0 = np.mean(our_method, axis = 0)
	oracle = np.array([dat[i][6] for i in range(l)])
	oracle0 = np.mean(oracle, axis = 0)
	
	vis(np.log(all_no_attack0), np.log(no_assis0), np.log(our_method0), np.log(oracle0))
	

